/* **********************************************************
 * Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
 * **********************************************************/
#define FILECODE "F(316)"

#ifdef linux
/* Must come before any kernel header file --hpreg */
#   include "driver-config.h"

#   include <linux/string.h>
#endif

#include "vmware.h"
#include "machine.h"
#include "hostif.h"
#include "cpuid.h"

static CPUOem oem;
static uint32 features;
static uint32 version;

void
CPUID_Init(void)
{
   uint32 regs[4];
   uint32 *ptr;
   char name[16];

   HostIF_GetCPUID(1, regs);
   version = regs[0];
   features = regs[3];

   HostIF_GetCPUID(0, regs);
   ptr = (uint32 *)name;
   ptr[0] = regs[1];
   ptr[1] = regs[3];
   ptr[2] = regs[2];
   ptr[3] = 0;

   if (strcmp(name, "GenuineIntel") == 0) {
      oem = CPUID_OEM_INTEL;
   } else if (strcmp(name, "AuthenticAMD") == 0) {
      oem = CPUID_OEM_AMD;
   } else if (strcmp(name, "CyrixInstead") == 0) {
      oem = CPUID_OEM_CYRIX;
   } else {
      Warning("VMMON CPUID: Unrecognized CPU\n");
      oem = CPUID_OEM_OTHER;
   }
}

CPUOem
CPUID_GetOEM(void)
{
   return oem;
}

uint32
CPUID_GetFeatures(void)
{
   return features;
}

uint32
CPUID_GetVersion(void)
{
   return version;
}

