/* **********************************************************
 * Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
 * **********************************************************/

#ifndef _CPUID_INFO_H
#define _CPUID_INFO_H

#include "vm_basic_types.h"

typedef struct CPUIDRegs {
   uint32 eax, ebx, ecx, edx;
} CPUIDRegs;

/*
 * Results of calling cpuid(eaxArg) on all logical processors. 
 */
typedef struct CPUIDResult {
   uint32 numLogicalCPUs;
   uint32 eaxArg;
   CPUIDRegs regs[0];
} CPUIDResult;


typedef struct CPUIDSummary {
   int numEntries;
   char name[16];
   struct {
      uint32 version;
      uint32 ebx;
      uint32 extFeatures;
      uint32 features;
   } id1;
} CPUIDSummary;

#endif
