/* **********************************************************
 * Copyright 2002 VMware, Inc.  All rights reserved. -- VMware Confidential
 * **********************************************************/

/*
 * Table of user calls, to be included as needed (typically twice:
 * for the enum declaration, and for a string table for printing).
 */

#define INCLUDE_ALLOW_USERLEVEL
#define INCLUDE_ALLOW_VMM
#define INCLUDE_ALLOW_VMKERNEL
#define INCLUDE_ALLOW_MODULE
#include "includeCheck.h"

/*
 * shared area, probably need to be static
 */
UC(SHAREDAREA_ALLOC)

/*
 * Essential services
 */

/*
 * basic
 */
UC(NOP)
UC(PANIC)
UC(WARNING)
UC(LOG)
UC(HALT)

/*
 * memory
 */
UC(PREALLOCANON)
UC(ALLOCANON)
UC(HOSTMONADDR)
UC(MEM_MARKUNCACHEABLE)
UC(GETDFCR3)
UC(LOOKUPMPN)

/*
 * interrupts
 */
UC(STATS)
UC(PERF)
   
/*
 * misc core monitor
 */
UC(CHECKPOINT_QUIESCE)
UC(IS_SMRAM_VISIBLE)
UC(ROM_REGION_WRITE)
UC(FLASHRAM_WRITE)

/*
 * device facilities
 */
UC(IOSPACE)
UC(FINALIZE)
UC(CHECKPOINT)
UC(VCPUPOLL)
UC(POLL)

/*
 * Misc. nonessential
 *
 * For example, there should be a monitor Msg_Post() to replace
 * USERCALL_FXSAVE_MISMATCH.
 */
UC(FXSAVE_MISMATCH)
UC(TCL)

UC(LICENSE)

/*
 * The rest are devices.
 */
UC(FASTCLOCKRATE)
UC(TIMER_BEEP)				
UC(GUEST_TIMER_CALIBRATION)

UC(DISK_BOGUSMBR)

UC(BROKEN_CPU)

UC(CLIHLT)
UC(TRIPLE_FAULT)
UC(IO_OVERLAP)
UC(IGNORE_FAULT)
UC(MON_BREAKPOINT)
UC(MON_SINGLESTEP)

UC(MONACT_ENQUEUE)
UC(MONACT_DEQUEUE)
UC(MONACT_DUMP)

UC(SVGA_WARN_LEGACY)

UC(VCPU_STARTALL)
UC(VCPU_STARTUP_IPI)
   
UC(COMMIT_DONE)
UC(VMEXT_GETVMMEINFO)
UC(CHANNEL)
UC(SEMA_INIT)
UC(SEMA_DESTROY)

UC(EXIT)
UC(FLASHRAM_GETPARAMS)
UC(BACKDOOR)
UC(PHYSMEM)

UC(LOGLEVEL_LOOKUP)

UC(SAVE_CMOS_TIMER)
UC(RESTORE_CMOS_TIMER)
UC(READ_CMOS)
UC(WRITE_CMOS)

UC(ST_CALLBACK)

UC(PIIX4PM_TIMER)

UC(MIGRATE_PROGRESS)

UC(VMK_REQUEST)
#undef UC
